      include 'copyrght.def'
C
C---------------------------------------------------------------
      integer function psl_init()
c Subroutine to initialize for arrays for the logic subroutines
C---------------------------------------------------------------
!      implicit none
!MS$ATTRIBUTES C, REFERENCE :: psl_init
      include 'pdfread.def'
      include 'bitops.def'

      include 'pdfdefs.par'

      include 'pdf.cmn'
      include 'logic.cmn'

      CHARACTER*(*) subrnm
      PARAMETER (subrnm='psl_init')
      character*80 file
      integer*4 i

      psl_init = 0

C get the database locations and read database sizes
      i = ps_readdbloc(dbloc, cdloc, localloc,
     $     N_cards,lastcrd,lastsub,N_reg,N_elemc )
      if (i .eq. -1) then
         call errmsg(subrnm,
     $        'Unable to determine the locations of ICDD database')
         psl_init = 1
         return
      elseif (i .eq. -2) then
         write (*,*) 
         call errmsg(subrnm,
     $        'Error reading the locations of ICDD database')
         psl_init = 1
         return
      elseif (i .eq. -3) then
         call errmsg(subrnm,
     $        'Unable to open file pdsize.txt on '//
     $        dbloc(:lench(dbloc)) // ' or ' //
     $        cdloc(:lench(cdloc)) )
         psl_init = 1
         return
      elseif (i .eq. -4) then
         call errmsg(subrnm,
     $        'Error reading file pdsize.txt on '//
     $        dbloc(:lench(dbloc)) // ' or ' //
     $        cdloc(:lench(cdloc)) )
         psl_init = 1
         return
      elseif (i .ne. 0) then
         call errmsg(subrnm,
     $        'Unknown error in ps_readdbloc')
         call errcode(subrnm,i)
         psl_init = 1
         return
      endif
!	write (*,*) 'Reading files from location ',dbloc(:lench(dbloc))
!	write (*,*) 'CDROM location ',cdloc(:lench(cdloc))
!	write (*,*) 'local AIDS entries ',localloc(:lench(localloc))
!      write (*,*) N_cards,lastcrd,lastsub,N_reg,N_elemc

      file = 'PDF2 database'
      i = ps_openpdf2 ('pdf2.dat'//char(0),dbloc,cdloc,0)
      if (i .eq. -1) call warnmsg(subrnm,
     $        'Unable to open file pdf2.dat on '//
     $        dbloc(:lench(dbloc)) // ' or ' //
     $        cdloc(:lench(cdloc)) )

      file = 'PDF1 database index (jcpds.ind)'
      i = ps_openindex(dbloc,cdloc)
      if (i .ne. 0) goto 20

      file = 'PDF1 name file (name.lib)'
      i = ps_opennamlib(dbloc,cdloc)
      if (i .ne. 0) goto 20

      file = 'PDF1 DI file (di.lib)'
      i = ps_opendilib(dbloc,cdloc)
      if (i .ne. 0) goto 20

      file = 'PDF1 reference file (ref.lib)'
      i = ps_openreflib(dbloc,cdloc)
      if (i .ne. 0) goto 20

C load the full database
      nphase = tblset(table, N_cards)
      cnum = 1
      context(1) = 'Starting from full database'
      return
C-------------------------------------------------------------------
 20   call errmsg(subrnm,
     $        'Unable to open file '//file(:lench(file))//' on '
     $        // dbloc(:lench(dbloc)) // ' or ' //
     $        cdloc(:lench(cdloc)) )
      call errmsg(subrnm,
     $     'Check paths in /usr/local/powder_suite.txt'//
     $     'or ~/.powder_suite')
      call errmsg(subrnm,
     $        'for correct database location')
      psl_init = 1
      return
      end









